/// <reference types="plasma" />
/// <reference types="@rbxts/compiler-types" />
/// <reference types="yetanothernet" />
/// <reference types="@rbxts/types" />
/// <reference types="@rbxts/types" />
import { Loop, World } from "@rbxts/matter";
import { Widgets } from "@rbxts/plasma";
import { Route } from "@rbxts/yetanothernet";
import { ComponentList } from "./utils";
export * from "./replicated";
export type GameLoop = Loop<[World, Widgets, Record<string, Route<any>>]>;
export type RouteList = Record<string, Route<any>>;
export default class MatterBootstrapper {
    private readonly systemContainer;
    private readonly components;
    private readonly routes;
    readonly world: World;
    private readonly hotReload;
    private readonly debugger;
    private readonly replication;
    private readonly loop;
    private readonly widgets;
    private readonly systems;
    constructor(systemContainer: Folder, components: ComponentList | any, routes?: RouteList, enableReplication?: boolean, enableHotReload?: boolean, enableDebugger?: boolean, debuggerKeycode?: Enum.KeyCode.BackSlash);
}
