/// <reference types="@rbxts/compiler-types" />
import { AnyComponent } from "@rbxts/matter/lib/component";
export type ComponentList = Record<string, (...args: any[]) => AnyComponent>;
/**
 * Fetches components marked as replicated with the \@Replicated decorator within a list of components
 *
 * @param components The list of components
 * @returns A subset of ``components`` including only components that are marked as Replicated (\@Replicated decorator)
 */
export declare const replicatedComponentsIn: (components: ComponentList) => ComponentList;
