-- Compiled with roblox-ts v2.1.1
local TS = _G[script]
local Reflect = TS.import(script, TS.getModule(script, "@rbxts", "experimental-reflect").out).Reflect
local Object = TS.import(script, TS.getModule(script, "@rbxts", "object-utils"))
local REPLICATED_METADATA_KEY = TS.import(script, script.Parent, "constants").REPLICATED_METADATA_KEY
--[[
	*
	* Fetches components marked as replicated with the \@Replicated decorator within a list of components
	*
	* @param components The list of components
	* @returns A subset of ``components`` including only components that are marked as Replicated (\@Replicated decorator)
]]
local replicatedComponentsIn = function(components)
	local replicatedComponents = {}
	for _, _binding in Object.entries(components) do
		local componentKey = _binding[1]
		local component = _binding[2]
		local isReplicated = Reflect.getMetadata(REPLICATED_METADATA_KEY, components, componentKey)
		if not (isReplicated ~= 0 and (isReplicated == isReplicated and (isReplicated ~= "" and isReplicated))) then
			continue
		end
		replicatedComponents[componentKey] = component
	end
	return replicatedComponents
end
return {
	replicatedComponentsIn = replicatedComponentsIn,
}
